/* GCC */
#include <utility>

std::pair<int, int> solds[50001];
int fen[1201][1201] = {};

void add(int x, int y, int val)
{
    x += 600, y += 600;
    for(int i = x; i < 1201; i |= (i+1))
        for(int j = y; j < 1201; j |= (j+1))
            fen[i][j] += val;
}

int sum(int x, int y)
{
    x += 600, y += 600;
    if(x < 0)
        x = 0;
    if(y < 0)
        y = 0;
    if(x > 1200)
        x = 1200;
    if(y > 1200)
        y = 1200;
    int ans = 0;
    for(int i = x; i >= 0; i = (i&(i+1))-1)
        for(int j = y; j >= 0; j = (j&(j+1))-1)
            ans += fen[i][j];
    return ans;
}

inline int sum(int x1, int y1, int x2, int y2)
{
    return sum(x2, y2) - sum(x1-1, y1) - sum(x1, y1-1) + sum(x1-1, y1-1);
}

void addSoldier(int x, int y, int s)
{
    solds[s] = std::make_pair(x+y+1000000, x-y+1000000);
    add(x+y, x-y, 1);
}

int removeSoldier(int s)
{
    if(solds[s].first == 0)
        return 0;
    add(solds[s].first-1000000, solds[s].second-1000000, -1);
    solds[s].first = solds[s].second = 0;
    return 1;
}

int query(int x, int y, int d)
{
    return sum(x+y-d, x-y-d, x+y+d, x-y+d);
}
